#!/usr/bin/perl -w

use strict;
use warnings;
use LWP 5.64;

require "/usr/bin/rnagios-plug.pl";

#Konfiguration:
my @config=();
open(DATEI, "</etc/remote-nagios/rnagios.conf") || die "Konfigurationsdatei nicht gefunden";
push(@config,<DATEI>);
close(DATEI);


my $configline="";
my $key="";
my $value="";
my %configuration=();

$configuration{"proxyurl"}="";
$configuration{"proxyport"}="";

foreach $configline (@config) {

if ($configline!~ /^(#.*|[\s]*)$/){
  chomp($configline);
  $configline =~ s/\s+//;
  ($key,$value) = split (/=/, $configline);
  chomp($key);
  chomp($value);
  
  $configuration{"$key"}=$value;
 }
}


my $sendipaddress=$configuration{"sendipaddress"};

my $hostip=$configuration{"hostip"};

my $username=$configuration{"username"};
my $password=$configuration{"password"};
my $realmname="remotenagios";
my $servername=$configuration{"servername"};
my $portnumber="80";
my $url = "http://".$servername."/remotenagios/server.php";


my $browser = LWP::UserAgent->new;

if ( ($configuration{"proxyurl"} !~ /^$/ ) && ($configuration{"proxyport"} !~ /^$/ ) ){
 $browser->proxy('http',$configuration{"proxyurl"}.":".$configuration{"proxyport"});
}

$browser->credentials(
	"$servername:$portnumber",
         $realmname,
	 $username => $password
);


for(;;) {

my $servicename;
my @plugins=pluginsauslesen();
my $plugin;

    
#inserts
my $sendhostname=$configuration{"hostname"}; ;
my $sendtime=time();
my @sendservicename=();
my @sendreturncode=();
my @sendpluginoutput=();

my $i=0;
my $line="";


foreach $line (@plugins) {
 my @return=();
 
 my $testcommand=$plugins[$i]{"command"};
 my $testname=$plugins[$i]{"name"};

 $testcommand =~ s/\$HOSTADDRESS\$/$hostip/g;

 my @vars=split (/\!/, $testname);
 my $servicename=$vars[0];
 $servicename=~ s/check_|check-//;
 shift(@vars);
 
 my $zahl=1;
 my $var="";
 foreach $var (@vars) {
  $testcommand =~ s/\$ARG$zahl\$/$var/;
  $zahl++;
 }

 @return = qx{ $testcommand};
 my $return_code = $?;
 
 chomp($return[0]); 
 
 if ($return_code >= 5) { $return[1]='3'; }

 if ($return[0] =~ /OK/) { $return[1]='0'; }
 if ($return[0] =~ /WARNING/) { $return[1]='1'; }
 if ($return[0] =~ /CRITICAL/) { $return[1]='2'; }
 if ($return[0] =~ /UNKNOWN/) { $return[1]='3'; }

 push(@sendservicename,$servicename);
 push(@sendreturncode,$return[1]);
 push(@sendpluginoutput,$return[0]);
$i++;
}

my $response = $browser->post( $url,
[ 'time' => $sendtime, 'returncode[]' => \@sendreturncode, 'hostname' => $sendhostname, 'pluginoutput[]' => \@sendpluginoutput, 'servicename[]' => \@sendservicename, 'ipaddress' => $sendipaddress ]
);

die "$url error: ", $response->status_line
unless $response->is_success;
die "Weird content type at $url -- ", $response->content_type
unless $response->content_type eq 'text/html';

sleep 15;
}
